module Atree where

data Atree a = Leaf a 
	      | Fork Int (Atree a) (Atree a)
		deriving(Show)

fork :: Atree a -> Atree a -> Atree a
fork xt yt = Fork (lsize xt) xt yt

lsize :: Atree a -> Int
lsize (Leaf x) = 1
lsize (Fork n xt yt) = n + lsize yt

mkAtree :: [a] -> Atree a
mkAtree xs 
    | (m==0) = Leaf (unwrap xs)
    | otherwise = fork (mkAtree yt) (mkAtree xt)
    where m = (length xs) `div` 2
	  (yt,xt) = splitAt m xs
	  unwrap [x] = x
	  
	  
t1 = mkAtree [1,2,3]
t2 = mkAtree [1,2,3,4,5,6,7]
t3 = mkAtree ["a","b","c"]
t4 = mkAtree ["a","b","c","d","e","f","g","h","i"]

retrieve :: Atree a -> Int -> a
retrieve (Leaf x) 0 = x
retrieve (Fork m xt yt) k = if k < m then retrieve xt k else retrieve yt (k-m)