module Stree where

-- Typdefinition eines Suchbaums

data (Ord a) => Stree a = Null
			| Fork (Stree a) a (Stree a)
			  deriving(Show)

-- flatten

flatten	:: (Ord a) => Stree a -> [a]
flatten Null = []
flatten (Fork xt x yt) = flatten xt ++ [x] ++ flatten yt


-- height

height :: (Ord a) => Stree a -> Int
height Null = 0
height (Fork xt y yt) = 1 + (height xt `max` height yt)

-- mkStree

mkStree :: (Ord a) => [a] -> Stree a
mkStree [] = Null
mkStree (x:xs) = Fork (mkStree smaller) x (mkStree larger)
		 where (smaller,larger) = partition (<= x) xs

-- partition

partition :: (a->Bool) -> [a] -> ([a],[a])
partition p xs = ([ x | x <- xs, p x],
		  [ y | y <- xs, (not . p) y])


sort :: (Ord a) => [a] -> [a]
sort = flatten . mkStree

-- ein Bespielbaum

t1 :: Stree Int
t1 = mkStree [18,15,12,8,3,2,4]

l1 = [18,15,12,8,3,2,4]

-- sort 

